#!/bin/sh

PROJ_DIR_OPT_TOOL_CHAIN=/opt/uclibc-toolchain/ifx-lxdb-1-3-1/gcc-3.3.6/toolchain-mips/bin
PROJ_DIR_OPT_CCACHE_PATH=/opt/uclibc-toolchain/ifx-lxdb-1-3-1/gcc-3.3.6/toolchain-mips/bin-ccache
PROJ_DIR_OPT_MKIMG=/opt/uclibc-toolchain/ifx-lxdb-1-3-1/hostutils/bin

export PATH="$PROJ_DIR_OPT_TOOL_CHAIN":"$PROJ_DIR_OPT_MKIMG":$PATH
export CCACHE_PATH="$PROJ_DIR_OPT_CCACHE_PATH"
LIBTARGET="../../../Source/target/lib/modules"

case "$1" in
#       gvv2)
#               ;;
	clean)
		make mrproper
		;;

	prepare)
		cp -f config.dm111.2M .config
		;;

	dm111_2M)
		cp -f config.dm111.2M .config
		;;

	dm111_4M)
		cp -f config.dm111.4M .config
		;;

	image_2M_flash_a)
#		cp -a drivers/char/amazon_se_mei_bsp_a.c drivers/char/amazon_se_mei_bsp.c
		make dep
		cp -f config.flash.2M .config
		make oldconfig
		make IFX_SMALL_FOOTPRINT=1 uImage
		;;

	image_2M_flash_b)
#		cp -a drivers/char/amazon_se_mei_bsp_b.c drivers/char/amazon_se_mei_bsp.c
		make dep
		cp -f config.flash.2M .config
		make oldconfig
		make IFX_SMALL_FOOTPRINT=1 uImage
		;;

	image_4M_flash_a)
#		cp -a drivers/char/amazon_se_mei_bsp_a.c drivers/char/amazon_se_mei_bsp.c
		make dep
		cp -f config.flash.4M .config
		make oldconfig
		make IFX_SMALL_FOOTPRINT=1 uImage
		;;

	image_4M_flash_b)
#		cp -a drivers/char/amazon_se_mei_bsp_b.c drivers/char/amazon_se_mei_bsp.c
		make dep
		cp -f config.flash.4M .config
		make oldconfig
		make IFX_SMALL_FOOTPRINT=1 uImage
		;;


	dep)
		make dep
		make oldconfig
		;;
	api_a)
		echo "Compile DSL API(3.7.2.9) for ANNEX A"
		cd ../../../Source/apps/dsl_api_3.6.2/
		rm -f drv_dsl_cpe_api dsl_cpe_control
		rm -f build_app.sh build_driver.sh build_platform_app.sh build_platform_driver.sh build.sh sysconfig.sh
		cp -a buildscript_3.7/*.sh .
		ln -sf drv_dsl_cpe_api_3.7.2.9 drv_dsl_cpe_api
		ln -sf dsl_cpe_control_3.7.2.9 dsl_cpe_control
		rm -f drv_dsl_cpe_api/configure.in
		cp -a buildscript_3.7/configure.in drv_dsl_cpe_api/configure.in
		./build_platform_driver.sh
		./build_platform_app.sh
		;;
	api_b)
		echo "Compile DSL API(3.7.2) for ANNEX B"
		cd ../../../Source/apps/dsl_api_3.6.2/
		rm -f build_app.sh build_driver.sh build_platform_app.sh build_platform_driver.sh build.sh
		cp -a buildscript_3.7/*.sh .
		rm -f drv_dsl_cpe_api dsl_cpe_control
		ln -sf drv_dsl_cpe_api_3.7.2 drv_dsl_cpe_api
		ln -sf dsl_cpe_control_3.7.2 dsl_cpe_control
		./build_platform_driver.sh
		./build_platform_app.sh
		;;		
	modules)
		make IFX_SMALL_FOOTPRINT=1 modules
		#mkdir -p $LIBTARGET	
		#cp $DRIVERPATH/char/drv_dsl_cpe_api $LIBTARGET
		#cp $DRIVERPATH/char/amazon_se_mei_bsp.o $LIBTARGET
		#cp $DRIVERPATH/char/amazon_se_mei.o $LIBTARGET
		cp net/ipv4/netfilter/ipt_string.o $LIBTARGET
		cp net/ipv4/netfilter/ipt_random.o $LIBTARGET
		cp net/ipv4/netfilter/ipt_limit.o $LIBTARGET
		cp net/ifx_nfext/ifx_nfext_core.o $LIBTARGET
		#cp net/ifx_nfext/ifx_nfext_ppp.o $LIBTARGET
#		cp drivers/net/pppoe.o $LIBTARGET
#		cp drivers/net/pppox.o $LIBTARGET
#		cp net/atm/pppoatm.o $LIBTARGET

#		cp drivers/atm/amazon_se_ppe.o $LIBTARGET
#		cp drivers/atm/koam.o $LIBTARGET
		#cp $DRIVERPATH/net/admmod.o $LIBTARGET
		#cp $DRIVERPATH/net/free_dma.o $LIBTARGET
		cp drivers/usb/gadget/dwc_otg_ifx.o $LIBTARGET
		cp drivers/usb/gadget/dwc_otg_gadget.o $LIBTARGET
		cp drivers/usb/gadget/g_ether.o $LIBTARGET
		cp net/ipv4/netfilter/ip_conntrack_sip.o $LIBTARGET
                cp net/ipv4/netfilter/ip_nat_sip.o $LIBTARGET
		;;
	img)
		make IFX_SMALL_FOOTPRINT=1 uImage
		;;

	* )
		echo "need argument!"
		exit
esac


